<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<div class="box span4" style="margin-top: 0px;">
	<div class="box-header well" data-original-title>
		<h2>
			<i></i> API Documentation
		</h2>
		<div class="box-icon">
			<a href="#" class="btn btn-minimize btn-round"> <i
				class="icon-chevron-up" id="icon-user" onclick="toggleAPI()"></i>
			</a>
		</div>
	</div>
	<div class="box-content main-menu-span " id="box-api">
		<div class="accordion" id="accordion2">

			<div class="accordion-group">

				<div class="accordion-heading" id="api-header">

					<a class="accordion-toggle" data-toggle="collapse"
						data-parent="#accordion2" href="#collapseOne"> poolSize </a>

				</div>

				<div id="collapseOne" class="accordion-body collapse"
					style="height: 0px;">

					<div class="accordion-inner" id="api-content">

						<p>The amount of people we simulated to generate actions .</p>

					</div>

				</div>

			</div>

			<div class="accordion-group">

				<div class="accordion-heading" id="api-header">

					<a class="accordion-toggle" data-toggle="collapse"
						data-parent="#accordion2" href="#collapseTwo">usePlugins </a>

				</div>

				<div id="collapseTwo" class="accordion-body collapse"
					style="height: 0px;">

					<div class="accordion-inner" id="api-content">

						<div>
							<h3 class="title">usePlugin</h3>
							<p>The plug-ins which help us to create scripts, such as
								CommandLinePlugin ,ConstantTimerPlugin,HttpPlugin and LogPlugin.</p>
						</div>
						<div>
							<span class="arguments">Arguments</span>
							<table class="details">
								<tbody>
									<tr>
										<td>id</td>
										<td>String</td>
									</tr>
									<tr>
										<td>The description of plug-in which we used.</td>
									</tr>
									<tr>
										<td>name</td>
										<td>String</td>
									</tr>
									<tr>
										<td>The name of plug-in,such as HTTP,ConstantTimer and so
											on.</td>
									</tr>
									<tr>
										<td>parameters</td>
										<td>Parameter[]</td>
									</tr>
									<tr>
										<td>The list of parameter,which include the important
											information of script which you are editing.</td>
									</tr>
								</tbody>
							</table>
						</div>
					</div>

				</div>

			</div>

			<div class="accordion-group">

				<div class="accordion-heading" id="api-header">

					<a class="accordion-toggle" data-toggle="collapse"
						data-parent="#accordion2" href="#collapseThree">pages </a>

				</div>

				<div id="collapseThree" class="accordion-body in"
					style="height: auto;">

					<div class="accordion-inner" id="api-content">
						<div>
							<h3 class="title">batches</h3>
							<p>a series of behaviors which you have made in the network.</p>
						</div>
						<div>
							<span class="arguments">Arguments</span>
							<table class="details">
								<tbody>
									<tr>
										<td>Id</td>
										<td>int</td>
									</tr>
									<tr>
										<td>The serial number of batches.</td>
									</tr>
									<tr>
										<td>parentId</td>
										<td>int</td>
									</tr>
									<tr>
										<td>The parent batch's serial number.</td>
									</tr>
									<tr>
										<td>childId</td>
										<td>int</td>
									</tr>
									<tr>
										<td>The child batch's serial number.</td>
									</tr>
									<tr>
										<td>behaviors</td>
										<td>Behavior[]</td>
									</tr>
									<tr>
										<td>A list of actions which you want the script to do.</td>
									</tr>
								</tbody>
							</table>
						</div>
						<div>
							<h3 class="title">behaviors</h3>
							<p>The actions you do with the network. There are two types
								of Behavior, namely TimerBehavior and UserBehavior.</p>
						</div>
						<div>
							<span class="arguments">Arguments</span>
							<table class="details">
								<tbody>
									<tr>
										<td>id</td>
										<td>int</td>
									</tr>
									<tr>
										<td>The serial number of behaviors you have choosed.</td>
									</tr>
									<tr>
										<td>use</td>
										<td>String</td>
									</tr>
									<tr>
										<td>The plug-in name which you have choosed, such as http
											and timer.</td>
									</tr>
									<tr>
										<td>name</td>
										<td>String</td>
									</tr>
									<tr>
										<td>The name of the method which you have choosed based
											on the type of plug-in.For example,when you generate the http
											request, you can use the method such as GET,POST,PUT and
											DELETE.</td>
									</tr>
									<tr>
										<td>type</td>
										<td>String</td>
									</tr>
									<tr>
										<td>The type of behavior, such as TIMEBEHAVIOR and
											USERBEHAVIOR.</td>
									</tr>
									<tr>
										<td>parameters</td>
										<td>Parameter[]</td>
									</tr>
									<tr>
										<td>The list of parameter,which include the important
											information of script which you are editing.</td>
									</tr>

								</tbody>
							</table>
						</div>
						<div>
							<h3 class="title">parameters</h3>
							<p>The specific information of your script.</p>
						</div>
						<div>
							<table class="details">
								<tbody>
									<tr>
										<td>key</td>
										<td>String</td>
									</tr>
									<tr>
										<td>The important parameters when you edit your
											script.For example, you should write the url(The URL for the
											resource we are requesting),queryParams and headers (A table
											of custom HTTP headers to send along with the request)</td>
									</tr>
									<tr>
										<td>value</td>
										<td>String</td>
									</tr>
									<tr>
										<td>The content of the key.</td>
									</tr>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>